<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: SimuCameraGL.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_simu_camera_g_l_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SimuCameraGL.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_simu_camera_g_l_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef SIMUCAMERAGL_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define SIMUCAMERAGL_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_simu_camera_8h.html">SimuCamera.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;SensorGL.h&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;ISceneNodeAnimator.h&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// in order to get function prototypes from glext.h, define GL_GLEXT_PROTOTYPES</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// before including glext.h</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define GL_GLEXT_PROTOTYPES</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;GL/gl.h&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceirr.html">irr</a> {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span>scene {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">class </span>ICameraSceneNode;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;}</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">namespace </span>gui {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">class </span>DoubleSpinBox;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">class </span>Vector3DSpinBox;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;}</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">namespace </span>simulator {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">class </span>Model;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;}</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">namespace </span>sensor {</div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classflair_1_1sensor_1_1_simu_camera_g_l.html">   47</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1sensor_1_1_simu_camera_g_l.html">SimuCameraGL</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1sensor_1_1_simu_camera.html">SimuCamera</a>,</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                     <span class="keyword">public</span> <a class="code" href="classflair_1_1sensor_1_1_sensor_g_l.html">SensorGL</a>,</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                     <span class="keyword">public</span> irr::scene::ISceneNodeAnimator {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  <span class="comment">// top left origin</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <a class="code" href="classflair_1_1sensor_1_1_simu_camera_g_l.html">SimuCameraGL</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1simulator_1_1_model.html">simulator::Model</a> *parent, std::string name, <span class="keywordtype">int</span> width,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;               <span class="keywordtype">int</span> height, <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, uint32_t modelId,uint32_t deviceId);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  ~<a class="code" href="classflair_1_1sensor_1_1_simu_camera_g_l.html">SimuCameraGL</a>();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1sensor_1_1_simu_camera_g_l.html#ab9fed80b79343744331b8cf6c2d22b9e">setNearValue</a>(<span class="keywordtype">float</span> zn);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1sensor_1_1_simu_camera_g_l.html#a423b0009af00935e7cc8e6b9f768f930">setFarValue</a>(<span class="keywordtype">float</span> zf);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordtype">void</span> UpdateFrom(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keywordtype">void</span> animateNode(irr::scene::ISceneNode *node, irr::u32 timeMs);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;  ISceneNodeAnimator *createClone(irr::scene::ISceneNode *node,</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;                                  irr::scene::ISceneManager *newManager = 0);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="keywordtype">void</span> getImage(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="keywordtype">void</span> putImage(<span class="keywordtype">char</span> *pixels,<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">core::Time</a> imageTime);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  irr::scene::ICameraSceneNode *camera;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  irr::scene::ISceneManager *smgr;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_vector3_d_spin_box.html">gui::Vector3DSpinBox</a> *position, *direction, *up;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <a class="code" href="classflair_1_1gui_1_1_double_spin_box.html">gui::DoubleSpinBox</a> *fov;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="keywordtype">int</span> width, height, x, y;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="keywordtype">char</span> *buffer;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordtype">bool</span> use_pbo, invert_pixel, disable_output;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;  GLuint *pboIds;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  <span class="keywordtype">int</span> index;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;};</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;} <span class="comment">// end namespace simulator</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="preprocessor">#endif // SIMUCAMERAGL_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_simu_camera_g_l_html_ab9fed80b79343744331b8cf6c2d22b9e"><div class="ttname"><a href="classflair_1_1sensor_1_1_simu_camera_g_l.html#ab9fed80b79343744331b8cf6c2d22b9e">flair::sensor::SimuCameraGL::setNearValue</a></div><div class="ttdeci">void setNearValue(float zn)</div><div class="ttdoc">Sets the value of the near clipping plane. (default: 1.0f) </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_acc0fa041e08ecf73b2d1d723c339a736"><div class="ttname"><a href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">flair::core::Time</a></div><div class="ttdeci">unsigned long long Time</div><div class="ttdoc">Time definition, in ns. </div><div class="ttdef"><b>Definition:</b> Object.h:55</div></div>
<div class="ttc" id="_simu_camera_8h_html"><div class="ttname"><a href="_simu_camera_8h.html">SimuCamera.h</a></div><div class="ttdoc">Class for a simulation camera. </div></div>
<div class="ttc" id="namespaceirr_html"><div class="ttname"><a href="namespaceirr.html">irr</a></div><div class="ttdef"><b>Definition:</b> Blade.h:22</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_simu_camera_g_l_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_simu_camera_g_l.html">flair::sensor::SimuCameraGL</a></div><div class="ttdoc">Class for a simulation camera. </div><div class="ttdef"><b>Definition:</b> SimuCameraGL.h:47</div></div>
<div class="ttc" id="classflair_1_1simulator_1_1_model_html"><div class="ttname"><a href="classflair_1_1simulator_1_1_model.html">flair::simulator::Model</a></div><div class="ttdef"><b>Definition:</b> Model.h:55</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_simu_camera_g_l_html_a423b0009af00935e7cc8e6b9f768f930"><div class="ttname"><a href="classflair_1_1sensor_1_1_simu_camera_g_l.html#a423b0009af00935e7cc8e6b9f768f930">flair::sensor::SimuCameraGL::setFarValue</a></div><div class="ttdeci">void setFarValue(float zf)</div><div class="ttdoc">Sets the value of the far clipping plane (default: 2000.0f) </div></div>
<div class="ttc" id="classflair_1_1gui_1_1_double_spin_box_html"><div class="ttname"><a href="classflair_1_1gui_1_1_double_spin_box.html">flair::gui::DoubleSpinBox</a></div><div class="ttdoc">Class displaying a QDoubleSpinBox on the ground station. </div><div class="ttdef"><b>Definition:</b> DoubleSpinBox.h:28</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_sensor_g_l_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_sensor_g_l.html">flair::sensor::SensorGL</a></div><div class="ttdef"><b>Definition:</b> SensorGL.h:35</div></div>
<div class="ttc" id="classflair_1_1gui_1_1_vector3_d_spin_box_html"><div class="ttname"><a href="classflair_1_1gui_1_1_vector3_d_spin_box.html">flair::gui::Vector3DSpinBox</a></div><div class="ttdoc">Class displaying 3 QDoubleSpinBox for x,y,z on the ground station. </div><div class="ttdef"><b>Definition:</b> Vector3DSpinBox.h:28</div></div>
<div class="ttc" id="classflair_1_1sensor_1_1_simu_camera_html"><div class="ttname"><a href="classflair_1_1sensor_1_1_simu_camera.html">flair::sensor::SimuCamera</a></div><div class="ttdoc">Class for a simulation camera. </div><div class="ttdef"><b>Definition:</b> SimuCamera.h:30</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_6c18a444e32a4cd48a96c3b539dd8d1b.html">FlairSimulator</a></li><li class="navelem"><a class="el" href="dir_601030f00f475cf118bb493a6f5bdaf5.html">src</a></li><li class="navelem"><a class="el" href="_simu_camera_g_l_8h.html">SimuCameraGL.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
